#include <windows.h>
#include <aygshell.h>
#include <fstream>
#include <string>
#include <Pm.h>
#include <Pmpolicy.h>

using namespace std;

void restorDefaultShortPress(){
	HKEY myKey;
	DWORD disposition;
	RegCreateKeyEx(HKEY_LOCAL_MACHINE, L"SOFTWARE\\Manila_QuickShutdown", 0, 0, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, 0, &myKey, &disposition);
	unsigned char action=0;
	RegSetValueEx(myKey,L"actionShortPress",0,REG_DWORD,(const BYTE*)&action,sizeof(unsigned char));
	RegCloseKey(myKey);

	if((long)GetFileAttributes(L"\\Windows\\Short_Power.lnk")>=0){
		DeleteFile(L"\\Windows\\Short_Power.lnk");
		if((long)GetFileAttributes(L"\\Windows\\Short_Power.old")>=0){
			//change the previous link:
			CopyFile(L"\\Windows\\Short_Power.old",L"\\Windows\\Short_Power.lnk",false);
		}
	}
}
void extractParams(wstring &lnkTarget,wstring &parameters){
	WCHAR target[255];
	if(lnkTarget.length()==0){
		parameters=L"";
		return;
	}

	while(lnkTarget.length()>0&&lnkTarget[lnkTarget.length()-1]<=(WCHAR)20)//bad char elimiation
		lnkTarget=lnkTarget.substr(0,lnkTarget.length()-1);

	if(lnkTarget[0]==L':'){//special character
		int pos=lnkTarget.find(L" ");

		if(pos!=wstring::npos&&pos+2<lnkTarget.length()){
			parameters=lnkTarget.substr(pos+1)+parameters;
		}
		lnkTarget=lnkTarget.substr(0,pos);
		//use register to load the menu (fastest way)
		wstring whichKey=L"Software\\Microsoft\\Shell\\Rai\\";
		whichKey=whichKey+lnkTarget;
		DWORD disposition;
		HKEY regKey;
		RegCreateKeyEx(HKEY_LOCAL_MACHINE, whichKey.c_str(), 0, 0, REG_OPTION_NON_VOLATILE,
			KEY_ALL_ACCESS, 0, &regKey, &disposition);
		WCHAR iconPathWCHAR[MAX_PATH];
		DWORD sizeValue=MAX_PATH*sizeof(WCHAR);
		if(RegQueryValueEx(regKey,L"1", 0, 0, (LPBYTE)iconPathWCHAR, &sizeValue)==ERROR_SUCCESS){
			lnkTarget=iconPathWCHAR;
			extractParams(lnkTarget,parameters);
		}
	}
	//the first caracter must be \:
	if(lnkTarget[0]!=L'\\'){
		wstring win=L"\\windows\\";
		lnkTarget=win+lnkTarget;
	}
	//last: separation of parameters:
	int posExe=lnkTarget.find(L".exe");
	if(posExe!=wstring::npos){
		if(posExe+5<lnkTarget.length()){
			parameters=lnkTarget.substr(posExe+5)+parameters;
			lnkTarget=lnkTarget.substr(0,posExe+4);
		}
	}
}
void shutdownDevice(){
	//notify taskbar:
	HWND taskbarUP = FindWindow(L"HHTaskBar", NULL);
	//Post the WM_POWERBROADCAST message with the flag PBT_APMSUSPEND
	SendMessage(taskbarUP,0x218,0x4,NULL);
	Sleep(500);

	HMODULE modDLL=LoadLibrary(L"\\Windows\\HTCUtil.dll");
	if(modDLL!=NULL){
		FARPROC HTCUtilDeviceOff;
		HTCUtilDeviceOff = GetProcAddress(modDLL,L"HTCUtilDeviceOff");
		if(NULL != HTCUtilDeviceOff){
			HTCUtilDeviceOff();
		}
	}

	ExitWindowsEx(EWX_POWEROFF,0);
	SetSystemPowerState(NULL, POWER_STATE_OFF, NULL);
}
void restartDevice(){
	//it's the restart action:
	if(ExitWindowsEx(EWX_REBOOT,0)!=NULL)
		return;

	//If not reseted, try to use reset program :
	if(GetFileAttributes(L"\\windows\\reset.exe")!=INVALID_FILE_ATTRIBUTES){
		SHELLEXECUTEINFO sei;
		memset(&sei, 0, sizeof(sei));
		sei.cbSize = sizeof(sei);//size of the structure in bytes
		sei.fMask=NULL;//Mask Flags-> don't close QuickShutdown
		sei.hwnd= NULL;//Handle to any message box,when this function execute
		sei.lpVerb=TEXT("open");//verb variables for open the file mentioned in lpFile
		sei.lpDirectory=NULL;//Working directory name.NULL tells the current working Dir
		sei.lpFile=L"\\windows\\reset.exe";//executable file Name(.exe)
		sei.lpParameters = NULL;//no parameters to file
		sei.nShow=SW_SHOWNORMAL; //It shows the window as normal windowL
		sei.hInstApp=NULL;

		ShellExecuteEx(&sei);
	}
	//if here, not rebooted, last try:
	SetSystemPowerState(NULL, POWER_STATE_RESET, NULL);
}
void turnOffDevice(bool keepAudio){
	//VK_POWER
	if(keepAudio)
		SetSystemPowerState(NULL, POWER_STATE_IDLE,POWER_FORCE);
	else
		PowerPolicyNotify(PPN_POWERBUTTONPRESSED,NULL);
}

void runProgram(bool quickShutdown){
	wstring regKey=L"SOFTWARE\\Manila_QuickShutdown";

	HKEY myKey;
	DWORD disposition;
	RegCreateKeyEx(HKEY_LOCAL_MACHINE, regKey.c_str(), 0, 0, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, 0, &myKey, &disposition);
	WCHAR myProg[MAX_PATH];
	DWORD sizeValue=MAX_PATH*sizeof(WCHAR);
	wstring prog;
	if(!quickShutdown){
		RegQueryValueEx(myKey,L"ProgToRun", 0, 0, (LPBYTE)myProg, &sizeValue);
		RegCloseKey(myKey);
		prog=myProg;
	}else{
		RegQueryValueEx(myKey,L"SourcesDirectory", 0, 0, (LPBYTE)myProg, &sizeValue);
		RegCloseKey(myKey);
		prog=myProg;
		int deb=prog.find(L"resources");
		if(deb!=wstring::npos)
			prog=prog.substr(0,deb);
		prog=prog+L"QuickShutdown.exe";
	}
	wstring params=L"";
	extractParams(prog,params);
	SHELLEXECUTEINFO sei;
	memset(&sei, 0, sizeof(sei));
	sei.cbSize = sizeof(sei);//size of the structure in bytes
	sei.fMask=NULL;//Mask Flags-> don't close QuickShutdown
	sei.hwnd= NULL;//Handle to any message box,when this function execute
	sei.lpVerb=TEXT("open");//verb variables for open the file mentioned in lpFile
	sei.lpDirectory=NULL;//Working directory name.NULL tells the current working Dir
	sei.lpFile=prog.c_str();//executable file Name(.exe)
	sei.lpParameters=params.c_str();//params
	sei.nShow=SW_SHOWNORMAL; //It shows the window as normal windowL
	sei.hInstApp=NULL;
	//On lance le ShellExecute
	ShellExecuteEx(&sei);
}

//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: Initialization, message loop
//-----------------------------------------------------------------------------
int PASCAL wWinMain(HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
#ifdef UNDER_CE
					LPWSTR lpCmdLine,
#else
					LPSTR lpCmdLine,
#endif
					int nCmdShow)
{
	DWORD state=0;
	HKEY myKey;
	DWORD disposition;
	long loadOK=RegCreateKeyEx(HKEY_LOCAL_MACHINE, L"SOFTWARE\\Manila_QuickShutdown", 0, 0, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, 0, &myKey, &disposition);

	DWORD timeState=0;
	DWORD sizeValue;

	unsigned char action;
	sizeValue=sizeof(unsigned char);
	if(RegQueryValueEx(myKey,L"actionShortPress", 0, 0, (LPBYTE)&action, &sizeValue)!=ERROR_SUCCESS)
		action=0;
	//special actions:
	if(action==2){//Run QuickShutdown
		runProgram(true);
		RegCloseKey(myKey);
		return 0;
	}
	if(action==3){//Run prog
		runProgram(false);
		RegCloseKey(myKey);
		return 0;
	}

	SYSTEMTIME time;
	GetLocalTime(&time);
	DWORD timeDWORD=time.wHour*3600+time.wMinute*60+time.wSecond;
	DWORD lastClick;
	sizeValue=sizeof(DWORD);
	if(RegQueryValueEx(myKey,L"lastPowerChange", 0, 0, (LPBYTE)&lastClick, &sizeValue)!=ERROR_SUCCESS)
		lastClick=0;

	sizeValue=sizeof(DWORD);
	long res=RegQueryValueEx(myKey,L"timeState", 0, 0, (LPBYTE)&timeState,&sizeValue);
	if(res==ERROR_SUCCESS){
		if(timeState==lastClick){//problem with service! Delete Short_press.lnk :
			restorDefaultShortPress();
			turnOffDevice(false);
			return 0;
		}
 		sizeValue=sizeof(DWORD);
		RegQueryValueEx(myKey,L"StateFlag", 0, 0, (LPBYTE)&state,&sizeValue);
		RegSetValueEx(myKey,L"lastPowerClick",0,REG_DWORD,(const BYTE*)&timeState,sizeof(DWORD));

		if(timeDWORD>timeState+2&&(state&POWER_STATE_ON)!=0){//2 second min && is ON
			//switch using id of element :
			switch (action)
			{
			case 1://Screen off
				turnOffDevice(true);
				break;
			case 2://Run QuickShutdown
				runProgram(true);
				break;
			case 3://Run prog
				runProgram(false);
				break;
			default:
				turnOffDevice(false);
			}
		}else
			SetSystemPowerState(NULL, POWER_STATE_ON,POWER_FORCE);
		RegCloseKey(myKey);
		return 0;
	}else{
		RegCloseKey(myKey);
		restorDefaultShortPress();
		turnOffDevice(false);
		return 0;
	}

	return 0;//*/
}